/**
 * @file	Trivial.java
 * 
 * @date	Feb 9, 2005
 * @author	Alexandre Bouchard
 */
package ca.mcgill.lmp.examples;

import ca.mcgill.lmp.LMP;
import ca.mcgill.lmp.approx.LMPApproximator;
import ca.mcgill.lmp.util.DiscreteSet;
import ca.mcgill.lmp.util.DiscreteState;
import ca.mcgill.lmp.util.kernels.DiscreteKernel;
import ca.mcgill.lmp.util.measures.UniformDiscreteMeasure;


/**
 * 
 *
 */
public class Trivial
{    
    /**
     * @param args
     */
    public static void main(String [] args)
    {
        DiscreteSet stateSpace = new DiscreteSet();
        DiscreteState s0 = new DiscreteState(0);
        stateSpace.add(s0);
        DiscreteKernel [] kernels = new DiscreteKernel[1];
        kernels[0] = new DiscreteKernel();
        kernels[0].setProbability(s0, s0, 1);
        kernels[0].setX(stateSpace);
        LMP lmp = new LMP(stateSpace, kernels, s0);    
        
        UniformDiscreteMeasure measure = new UniformDiscreteMeasure(stateSpace);
        
        LMPApproximator approximator = new LMPApproximator(lmp, measure);
        
        LMP approximation = approximator.approximate(0.5, 5);
        System.out.println("Test complete.");
    }
}
