/**
 * @file	Exercise.java
 * 
 * @date	Feb 3, 2005
 * @author	Alexandre Bouchard
 */
package ca.mcgill.lmp.tests.montecarlo;

import ca.mcgill.lmp.MeasurableFunction;
import ca.mcgill.lmp.State;
import ca.mcgill.lmp.approx.MonteCarlo;
import ca.mcgill.lmp.util.MultiInterval;
import ca.mcgill.lmp.util.RnState;
import ca.mcgill.lmp.util.measures.BorelMeasure;

/**
 * 
 *
 */
public class Exercise
{

    public static void main(String[] args)
    {
        MultiInterval unitInterval = new MultiInterval(0, 1);
        BizFunction f = new BizFunction();
        MonteCarlo integrator = new MonteCarlo(new BorelMeasure(1));
        integrator.setMonteCarloTrials(10000000);
        System.out.println("Integral of the fct over [0,1] = " + 100*integrator.integrate(f));
    }
}

class BizFunction implements MeasurableFunction
{

    /**
     * @param s
     * @return
     */
    public double evaluateAt(State s)
    {
        RnState point = (RnState) s;
        double x = point.getCoordinate(0) * 100 + 9;
        return Math.log(x) / Math.pow(x, 4);
    }
    
}