/**
 * @file 	MonteCarlo.java
 * 
 * @date 	Jan 16, 2005
 * @author 	Alexandre Bouchard
 */
package ca.mcgill.lmp.util;

import ca.mcgill.lmp.State;

/**
 * 
 * 
 */
public class RnState implements State
{
    private double [] coordinates;
    
    public RnState(double [] coordinates)
    {
        this.coordinates = coordinates;
    }
    
    public RnState(double value)
    {
        this.coordinates = new double[1];
        coordinates[0] = value;
    }
    
    public double getCoordinate(int index)
    {
        return coordinates[index];
    }
    
    public int getDimensionality()
    {
        return coordinates.length;
    }
    
    public String toString()
    {
        StringBuffer buffer = new StringBuffer();
        buffer.append("(");
        for (int i = 0; i < getDimensionality(); i++)
        {
            buffer.append("" + getCoordinate(i));
            if (i != getDimensionality() - 1)
            {
                buffer.append(", ");
            }
        }
        buffer.append(")");
        return buffer.toString();
    }
}
