/**
 * @file        MonteCarlo.java
 *
 * @date        Jan 16, 2005
 * @author      Alexandre Bouchard
 */

package trash;

//import ca.mcgill.lmp.MeasurableSet;
//import ca.mcgill.lmp.MeasurableFunction;
//import ca.mcgill.lmp.State;
//import ca.mcgill.lmp.util.MultiInterval;
//import ca.mcgill.lmp.util.functions.CharacteristicFunction;

/**
 *
 */
public class MonteCarlo
{
    /**
     * Comment for <code>monteCarloTrials</code>
     *
    public static int monteCarloTrials = 500000;
    
    /**
     * Comment for <code>probabilitySpace</code>
     *
    private MeasurableSet probabilitySpace;
    
    /**
     * @param probabilitySpace
     *
    public MonteCarlo(MeasurableSet probabilitySpace)
    {
        this.probabilitySpace = probabilitySpace;
    }

    /**
     * @param f
     * @param D
     * @return
     *
    public double integrate(MeasurableFunction f, MeasurableSet D)
    {
        double partialSum = 0;
        for (int counter = 0; counter < monteCarloTrials; counter++)
        {
            State currentState = probabilitySpace.sampleUniformly();
            if (D.contains(currentState))
            {
                partialSum = partialSum + f.evaluateAt(currentState);
            }    
        }
        return partialSum / (double) monteCarloTrials;
    }
    
    public double integrate(MeasurableFunction f)
    {
        return integrate(f, probabilitySpace);
    }

    /**
     * @param f
     * @param D
     * @return
     *
    public static double inf(MeasurableFunction f, MeasurableSet D)
    {
        double partialMin = Double.MAX_VALUE;
        for (int counter = 0; counter < monteCarloTrials; counter++)
        {
            double currentValue = f.evaluateAt(D.sampleUniformly());
            if (currentValue < partialMin)
            {
                partialMin = currentValue;
            }
        }
        return partialMin;
    }
    
    public static void main(String [] args)
    {
        MultiInterval unitSquare = new MultiInterval(2);
        CharacteristicFunction constant = new CharacteristicFunction(unitSquare);
        MonteCarlo monteCarlo1 = new MonteCarlo(unitSquare);
        System.out.println("This integral should be close to 1: " + monteCarlo1.integrate(constant));
        
    }*/
}